import { Component, OnInit } from '@angular/core';


import { ToastrService } from 'ngx-toastr';
import { ActivatedRoute, Router } from '@angular/router';
import { College } from 'src/app/models/fnd/play';
import { student } from 'src/app/models/fnd/Studentadd';
import { AbstractControl, FormBuilder, FormGroup, ValidationErrors, Validators } from '@angular/forms';
import { Observable } from 'rxjs';
import { ValidationError } from 'src/app/models/fnd/ValidationError';
import { ssssservice } from './ssss.service';
declare var JsBarcode: any;
  @Component({
  selector: 'app-editstepper',
  templateUrl: './ssss.component.html',
  styleUrls: ['./ssss.component.scss']
})
export class ssssComponent implements OnInit {
  updated = false;
  stringJson: any;
  customerId: string = '';
  selectedFile!: File;
  fileName = '';

  id: number;
  errorFields: ValidationError[] = [];
  appToUpdate: College = null;
  trained = false;

  json: string = "";
  luisApp =
    {
      name: '',
      created: 1,
      trained: 1,
      tested: 1,
      updated: 1,
      published: 1,

    };
  // Layout direction changing
  layout = {
    direction: "vertical",
    block1: "clr-col-lg-3 clr-col-12 ",
    block2: "clr-col-lg-9 clr-col-12 ",
  };

  timelineStyle = { 
 step0: { state: "current", open: true, failed: false }, 
    step1: { state: "not-started", open: false, failed: false },
};
public FormaentryForm: FormGroup;
  submitted = false;
  rowSelected: any = {};
  modalcomplete = false;

  constructor( 
private mainService: ssssservice,

private kkkk_fb: FormBuilder, 
private router: Router,
 private route: ActivatedRoute,
    private toastr: ToastrService,
  ) { }

  ngOnInit(): void {
    this.id = this.route.snapshot.params["id"];
    console.log("update with id = ", this.id);


 this.FormaentryForm = this.kkkk_fb.group({ 
name : [null],

radio_field : [null],

  
 
o:[false],
   

 
p:[false],
   


currency : [null, { updateOn: 'blur' }],

qrcode_field : [null],

barcode_field : [null],


  });












 const stepId = this.id; // or from route/query/etc
 
    this.getResolvedDataFromStepper(stepId).subscribe(res => {
      console.log('response get ', res);

      if (res === null) {
        this.showEmptyForm();
      } else {
 if (res['Forma']) {
 
 this.prefillkkkkForm(res['Forma']);
        }
}
    });

  }
showEmptyForm(): void {
    console.log('No config found. Showing empty form.');
    // You can choose to show one or both based on some logic

 this.FormaentryForm.reset();
  }  prefillkkkkForm(data: any): void {

    console.log(' kkkk data ', data)
    this.FormaentryForm.patchValue({
      id: data.id || '',
name: data.name || '',

radio_field: data.radio_field || '',

checkbox_field: data.checkbox_field || '',

currency: data.currency || '',

qrcode_field: data.qrcode_field || '',

barcode_field: data.barcode_field || '',

    });
  }
 getResolvedDataFromStepper(id: number): Observable<any> {
    console.log('get step config');

    return new Observable(observer => {
      this.mainService.gettabledata(id).subscribe(configList => {
        if (!configList || configList.length === 0) {
          console.log('empty config');
          observer.next(null);
          observer.complete();
          return;
        }

        const results: { [key: string]: any } = {};
        let processed = 0;

        configList.forEach(config => {
          const { table_name, table_id } = config;

          this.getByTableNameAndId(table_name, table_id).subscribe(data => {

            console.log('data is ', data);
            results[table_name] = data;

            processed++;
            if (processed === configList.length) {
              observer.next(results);  // emit combined data
              observer.complete();
            }

          }, error => {
            console.error(`Error loading data for table ${table_name}`, error);
            processed++;
            if (processed === configList.length) {
              observer.next(results);  // continue with what we have
              observer.complete();
            }
          });
        });

      }, error => {
        console.error("Error loading stepper config", error);
        observer.error(error);
      });
    });
  }



  getByTableNameAndId(tableName: string, id: number): Observable<any> {

    switch (tableName) {
   case 'Forma':
        return this.mainService.getFormaById(id);// aur bhi cases agar naye table add ho to
      default:
        throw new Error(`Unknown table name: ${tableName}`);
    }
  }
  // Change to Horizontal Layout
  changeToHorizonTal() {
    this.layout = {
      direction: "horizontal",
      block1: "clr-col-lg-12 clr-col-12 height container",
      block2: "clr-col-lg-12 clr-col-12 container",
    }
  }
  // Change to Vertical Layout
  changeToVertical() {
    this.layout = {
      direction: "vertical",
      block1: "clr-col-lg-3 clr-col-12 ",
      block2: "clr-col-lg-9 clr-col-12 ",
    }
  }



  onkkkkSave() {
    console.log('Form Submitted:', this.FormaentryForm.value);
    this.submitted = true;
    if (this.FormaentryForm.invalid) {

      console.log('invalid form ..');
      // Log all form errors
      Object.keys(this.FormaentryForm.controls).forEach(field => {
        const control = this.FormaentryForm.get(field);
        if (control && control.invalid) {
          console.log(`Error in field: ${field}`, control.errors);
        }
      }
      );
      return;
    }
    this.onkkkkCreate();
  }

  onkkkkCreate() {












    this.mainService.createForma(this.FormaentryForm.value).subscribe(
      (data) => {
        console.log('adding data ', data);
        this.customerId = data.id;

        console.log('id is  ', this.customerId);


 const tableId = data.id;
        const tableName = 'Forma';
        const stepperId = this.id;

        // Save stepper config
        this.mainService.saveStepperConfig(stepperId, tableId, tableName).subscribe(() => {
          this.toastr.success("Stepper Config Saved");
        });        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
        setTimeout(() => {
          this.ngOnInit();
        }, 500);













      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    this.rowSelected = this.FormaentryForm.value;

    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }


  onnext() {
    this.router.navigate(["../../main/workflow"], { relativeTo: this.route });
  }
  reset() {
    this.json = "";
    this.luisApp =
    {
      name: '',
      trained: 1,
      tested: 1,
      updated: 1,
      published: 1,
      created: 1,

    };

    this.timelineStyle = {
      step0: { state: "current", open: true, failed: false },
      step1: { state: "not-started", open: false, failed: false },
 };
  }
  current() {
    console.log(this.timelineStyle)
    this.stringJson = JSON.stringify(this.timelineStyle);
    console.log("String json object :", this.stringJson);

  }


updateradio_field (radio_field : string): void {    
 this.FormaentryForm.get('radio_field').setValue(radio_field);   }

updateradio_fieldEdit(radio_field : string): void {    this.rowSelected.radio_field  =  radio_field }
						 ;



//currency  field start
   formatCurrencycurrency () {
    // Format the currency with two decimal places    
	this.rowSelected.currency = Number(this.rowSelected.currency ).toFixed(2);
    // Remove commas from the formatted currency   
	 this.rowSelected.currency = this.rowSelected.currency?.replace(/,/g, '');  }
  //currency  field end



//bar code field start 
     generateBarcodebarcode_field(value) {
      const barcodeValue = value;
      const barcodeElement = document.getElementById("barcodebarcode_field"); 
      if (barcodeElement) {         if (barcodeValue) {
          JsBarcode(barcodeElement, barcodeValue, {             format: "CODE128"
          });         } else {
          // Clear the barcode if the input is empty
          barcodeElement.innerHTML = '';         }       }     }
         //    bar code field end 













// updateaction
}











